/** @file	kern_thread.c
 *  @brief	kernel thread
 *  Copyright (c) kaworu
 *  $Id: kern_thread.c,v 1.19 2003/12/05 12:12:27 kaworu Exp $
 *  @author	kaworu
 *  @date	since 2002/10/26 update: $Date: 2003/12/05 12:12:27 $
 *  @version	$Revision: 1.19 $
 */
asm (".code32");
#include "std.h"

void con_puts (char *ptr);

//static char *s1 = "kernel\0";
PUBLIC void init_idt (void);

/**
 * @breif	kernel thread
 * @author	kaworu
 * @date	since: 2003/10/26
 */
void
kern_thread ()
{
	//void	putc (int c);
	//void	con_printi (int i);
	extern int rtc_get_time ();
	extern void idle ();
	int	i;

	init_idt ();
	i8259a_init ();

	kprintf ("Phase0x: %s(%d)", "kernel", 2003);
	con_puts (__func__);
	kprintf ("\n");
	//for (i = 0; i < 4; i++)
	for ( ; ; )
	{
		rtc_get_time ();
		kprintf ("\r");
	}

	idle ();

	HALT;

	/* NOTREACHD */
#if 0
	return;
#endif
}
