/** @file	kernel.S
 *  @brief	start of dummy kernel
 *  Copyright (c) kaworu
 *  $Id: kernel.S,v 1.24 2003/12/04 17:04:13 kaworu Exp $
 *  @author	kaworu
 *  @date	since 2003/06/21 update: $Date: 2003/12/04 17:04:13 $
 *  @version	$Revision: 1.24 $
 */
#include "boot.h"
	.code32		// This runs in protect mode
	//.code16gcc	// This runs in real mode
	.text
	.global		start
	.global		putx
	.global		idle
	.global		dummy
	.global		con_init
	.global		kern_thread
start:
/* banner(test) */
#if 1
	xorl	%eax,	%eax
	//movl	$0xb8000,	%eax
	movl	$0xb8ab2,	%eax
	//movw	$0x0761,	(%eax)
	movw	$0x0100|'a',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0200|'r',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0300|'t',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0400|'e',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0500|'s',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0600|'i',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0700|'a',	(%eax)

	incl	%eax
	incl	%eax
	movw	$0x0800|'8',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0900|'9',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0a00|'a',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0b00|'b',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0c00|'c',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0d00|'d',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0e00|'e',	(%eax)
	incl	%eax
	incl	%eax
	movw	$0x0f00|'f',	(%eax)

	//movl	$ SYMBOL_NAME(__bss_start),	%edi
	call	con_init
	//call	scroll
//	pushl	$'c'
//	call	con_write
	call	kern_thread
#endif
	//jmp	die
	// dummy for test
	movl	$banner,	%esi
#	call	putx
die:
	jmp die
//	pushl	$str1
//	call	kprintf
//	call	kputs
loop:
//	call	xsh
	jmp loop			// forever
//ENTRY(idle)
idle:
	hlt
	jmp	idle

banner:
        .ascii	"Phase0x:kernel\n\r"
	.byte	0

